jQuery(document).ready(function () {
	
	// Apply settings on page load
	jQuery('.en-cheapest-rate-error').hide();
	jQuery('#selected_carriers_cheapest_rate').attr('multiple', 'multiple');
	
	let selected_options = jQuery('#selected_options_cheapest_rate').val();
	if (selected_options && selected_options.length) {
		selected_options = selected_options?.split(',');
	}
	
	const is_enabled = jQuery('#enable_disable_cheapest_rate').val();
	if (Boolean(is_enabled) && is_enabled != 'false') {
		jQuery('#enable_cheapest_rate').attr('checked', is_enabled);
	}

	jQuery('#selected_carriers_cheapest_rate').val(selected_options);

	const cheapest_rate_selection = jQuery('input[name="cheapest_rate_selection"]:checked').val();
	if (cheapest_rate_selection == 'standard_commercial_rate') {
		jQuery('.additional_services_cheapest_rate').prop('disabled', true);
	}

	// Validate settings on selection
	jQuery('input[name="cheapest_rate_selection"]').change(function (e) {
		const val = jQuery(this).val();

		if (val == 'standard_commercial_rate') {
			jQuery('.additional_services_cheapest_rate').prop('disabled', true);
		} else {
			jQuery('.additional_services_cheapest_rate').prop('disabled', false);
		}
	});

	// When saving settings
	jQuery('.cheapest_rate_quote_settings .button-primary').on('click', function (e) {
		e.preventDefault();
		jQuery('.en-cheapest-rate-error').remove();

		const enabled = jQuery('#enable_cheapest_rate').prop('checked');
		const selected_plugins = jQuery('#selected_carriers_cheapest_rate').val();
		if (selected_plugins && selected_plugins?.length < 2) {
			jQuery('.en-cheapest-rate-heading').after(
				'<div class="notice notice-error en-cheapest-rate-error"><p><strong>Error! </strong> Please select at least two plugin options.</p></div>'
			);

			return false;
		}

		const cheapest_rate_selection = jQuery('input[name="cheapest_rate_selection"]:checked').val();
		const additional_services = jQuery('input[name="additional_services_cheapest_rate"]:checked').val();

		const postForm = {
			action: 'en_wd_save_selected_plugins',
			selected_plugins,
			enabled,
			cheapest_rate_selection,
			additional_services
		};

		jQuery.ajax({
			type: 'POST',
			url: ajaxurl,
			data: postForm,
			dataType: 'json',

			beforeSend: function () {
				jQuery('.cheapest_rate_quote_settings .button-primary')
					.addClass('spinner_disable')
					.text('Loading ...');
			},
			success: function (data) {
				const error_class = data.error ? 'notice-error' : 'notice-success';
				const message = data.error ? '<strong>Error! </strong>' : '';

				jQuery('.cheapest_rate_quote_settings .button-primary')
					.removeClass('spinner_disable')
					.text('Save Changes');
				jQuery('.en-cheapest-rate-heading').after(
					`<div class="notice ${error_class} en-cheapest-rate-error"><p> ${message} ${data.message}</p></div>`
				);
			},
			error: function (err) {
				console.log('err: ', err);
				jQuery('.cheapest_rate_quote_settings .button-primary')
					.removeClass('spinner_disable')
					.text('Save Changes');
			},
		});
	});
});